unit frmMain;

interface

uses
  Windows, Messages, Graphics, Forms, OpenGL, Classes, Controls,
  ExtCtrls, mmSystem, ComCtrls, StdCtrls;

type
  TfrmGL = class(TForm)
    Panel1: TPanel;
    Shape1: TShape;
    TrackBar1: TTrackBar;
    Image1: TImage;
    Button1: TButton;
    Timer1: TTimer;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);

  private
    DC : HDC;
    hrc : HGLRC;
    Angle : GLfloat;
    uTimerId : uint;
    wrkX, wrkY : Array [0..5] of Single;

    procedure SetDCPixelFormat;
    procedure PrepareImage;
  end;

const
  CUBE = 1;

var
  frmGL: TfrmGL;
  zoom: real;

implementation

{$R *.DFM}

//  
procedure FNTimeCallBack (uTimerID, uMessage: UINT; dwUser, dw1, dw2: DWORD) stdcall;
begin
  frmGL.Angle := frmGL.Angle + 0.2;
  if (frmGL.Angle >= 720.0)
  then frmGL.Angle := 0.0;
  InvalidateRect(frmGL.Handle, nil, false);
end;

//  
procedure TfrmGL.FormCreate(Sender: TObject);
var
  i: 0..5;
begin
 DrawIconEx(Image1.Canvas.Handle, 0, 0, Application.Icon.Handle,
    Image1.ClientHeight, Image1.ClientWidth, 0, 0, DI_NORMAL);
 //
 zoom:=16;
 //
  Angle := 0;
  DC := GetDC (Panel1.Handle);
  SetDCPixelFormat;
  hrc := wglCreateContext (DC);
  wglMakeCurrent (DC, hrc);

  glEnable (GL_DEPTH_TEST);

  PrepareImage;

  {---    ---}
  glNewList (CUBE, GL_COMPILE);
    glScalef (0.25, 0.25, 0.25);
    glBegin (GL_QUAD_STRIP);
        glTexCoord2d (0.0, 1.0);
        glVertex3f (-1.0,  1.0, 1.0);  // 1
        glTexCoord2d (0.0, 0.0);
        glVertex3f (-1.0, -1.0, 1.0);  // 2
       	glTexCoord2d (1.0, 1.0);
        glVertex3f (1.0,  1.0, 1.0);   // 3
        glTexCoord2d (1.0, 0.0);
        glVertex3f (1.0, -1.0, 1.0);   // 4
      	glTexCoord2d (0.0, 1.0);
        glVertex3f (1.0, 1.0, -1.0);   // 5
      	glTexCoord2d (0.0, 0.0);
        glVertex3f (1.0, -1.0, -1.0);  // 6
        glTexCoord2d (1.0, 1.0);
        glVertex3f (-1.0,  1.0, -1.0); // 7
        glTexCoord2d (1.0, 0.0);
        glVertex3f (-1.0, -1.0, -1.0); // 8
      	glTexCoord2d (0.0, 1.0);
        glVertex3f (-1.0,  1.0, 1.0);  // 9
        glTexCoord2d (0.0, 0.0);
        glVertex3f (-1.0, -1.0, 1.0);  // 10
    glEnd;

    glBegin (GL_QUADS);
        glTexCoord2d (1.0, 0.0);
        glVertex3f (-1.0, 1.0, 1.0);
	glTexCoord2d (1.0, 1.0);
        glVertex3f (1.0, 1.0, 1.0);
	glTexCoord2d (0.0, 1.0);
        glVertex3f (1.0, 1.0, -1.0);
        glTexCoord2d (0.0, 0.0);
        glVertex3f (-1.0, 1.0, -1.0);
    glEnd;

    glBegin (GL_QUADS);
      glTexCoord2d (1.0, 0.0);
      glVertex3f (-1.0, -1.0, 1.0);
      glTexCoord2d (1.0, 1.0);
      glVertex3f (1.0, -1.0, 1.0);
      glTexCoord2d (0.0, 1.0);
      glVertex3f (1.0, -1.0, -1.0);
      glTexCoord2d (0.0, 0.0);
      glVertex3f (-1.0, -1.0, -1.0);
    glEnd;

    glScalef (4, 4, 4);

  glEndList;

  glClearColor (1.0, 0.75, 0.75, 0.0);
  uTimerID := timeSetEvent (4, 0, @FNTimeCallBack, 0, TIME_PERIODIC);
end;

//  
procedure TfrmGL.PrepareImage;

type
  PPixelArray = ^TPixelArray;
  TPixelArray = array [0..0] of Byte;

var
  Bitmap : TBitmap;
  Data : PPixelArray;
  BMInfo : TBitmapInfo;
  I, ImageSize : Integer;
  Temp : Byte;
  MemDC : HDC;
begin
  Bitmap := TBitmap.Create;
  // Bitmap.LoadFromFile ('server.bmp'); // client, server, i_am
  Bitmap.Assign(Image1.Picture);
  with BMinfo.bmiHeader do begin
    FillChar (BMInfo, SizeOf(BMInfo), 0);
    biSize := sizeof (TBitmapInfoHeader);
    biBitCount := 24;
    biWidth := Bitmap.Width;
    biHeight := Bitmap.Height;
    ImageSize := biWidth * biHeight;
    biPlanes := 1;
    biCompression := BI_RGB;

    MemDC := CreateCompatibleDC (0);
    GetMem (Data, ImageSize * 3);
    try
      GetDIBits (MemDC, Bitmap.Handle, 0, biHeight, Data, BMInfo, DIB_RGB_COLORS);
      For I := 0 to ImageSize - 1 do begin
          Temp := Data [I * 3];
          Data [I * 3] := Data [I * 3 + 2];
          Data [I * 3 + 2] := Temp;
      end;   
      glTexImage2d(GL_TEXTURE_2D, 0, 3, biWidth,
                   biHeight, 0, GL_RGB, GL_UNSIGNED_BYTE, Data);

      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
      glEnable(GL_TEXTURE_2D);
     finally
      FreeMem (Data);
      DeleteDC (MemDC);
      Bitmap.Free;
   end;
  end;
end;

//  
procedure TfrmGL.FormPaint(Sender: TObject);
var
 iR,iG,iB: Byte;
begin
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 //
 ir:=(TrackBar1.Position) mod 256;        // R
 ig:=(TrackBar1.Position shr 8) mod 256;  // G
 ib:=(TrackBar1.Position shr 16) mod 256; // B
 // glClearColor (ir, ig, ib, 1.0); //   
 // glClearColor (0.100, 0.30, 0.50, 1.0); //   
 glClearColor (1, 1, 1, 1.0); //   
 glClear (GL_COLOR_BUFFER_BIT);       //   
 //
 glLoadIdentity;
 glTranslatef (0.0, 0.0, -9.0);
 glRotatef (30.0, 1.0, 0.0, 1.0);
 glRotatef (Angle, 0.0, 0.0, 1.0);
 //
 glPushMatrix;
 // glTranslatef(wrkX [i], wrkY [i], 0.0);
 glRotatef(30.0, 0.0, 1.0, 0.0);
 glCallList (CUBE);
 glPopMatrix;
 //
 SwapBuffers(DC);
end;

//   
procedure TfrmGL.SetDCPixelFormat;
var
  nPixelFormat: Integer;
  pfd: TPixelFormatDescriptor;
begin
  FillChar (pfd, SizeOf (pfd), 0);

  with pfd do begin
    nSize     := sizeof (pfd);
    nVersion  := 1;
    dwFlags   := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
    iPixelType:= PFD_TYPE_RGBA;
    cColorBits:= 24;
    cDepthBits:= 32;
    iLayerType:= PFD_MAIN_PLANE;
  end;
  //
  nPixelFormat := ChoosePixelFormat (DC, @pfd);
  SetPixelFormat (DC, nPixelFormat, @pfd);
end;

//   
procedure TfrmGL.FormResize(Sender: TObject);
begin
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity;
  // zoom = 16.0
  gluPerspective(zoom, Panel1.Width / Panel1.Height, 6.0, 10.0);
  glViewport(0, 0, Panel1.Width, Panel1.Height);
  glMatrixMode(GL_MODELVIEW);
end;

//   
procedure TfrmGL.FormDestroy(Sender: TObject);
begin
  timeKillEvent (uTimerID);
  glDeleteLists (CUBE, 1);
  wglMakeCurrent (0, 0);
  wglDeleteContext (hrc);
  ReleaseDC (Panel1.Handle, DC);
end;

procedure TfrmGL.Button1Click(Sender: TObject);
begin
 zoom:=zoom+1.0;
 if zoom>110
 then zoom:=2.0;
 frmGL.OnResize(Sender);
end;

procedure TfrmGL.Button2Click(Sender: TObject);
begin
 Timer1.Enabled:=not Timer1.Enabled;
end;

end.

