unit Globals;

interface

uses Windows, dglOpenGL, Textures, SysUtils;

const
 INTRO_START  = 0;
 INTRO_TUNNEL = 10000;

type
 TNormal = record
       X, Y, Z : glFloat;             // X, Y, Z coordinates
 end;
 TVertex = record
       X, Y, Z : glFloat;             // X, Y, Z coordinates
 end;
 TTexCoord = record
       U, V : glFloat;                // U and V Texture coordinates
 end;

// Textures
var ProgressTex   : glUint;               // Loading Stage
    DemoNameTex   : glUint;               // Intro (Band Name)
    IntroBG       : glUint;               // Intro (Full Band Pic in negative)
    Logo          : glUint;               // Intro (Fuzzy Volition Logo) 

type TGLCoord = Record
       X, Y, Z : glFloat;
     end;

// Other Global variables
var
 ElapsedTime : Integer;                // Elapsed time between frames
 Stage : Integer;                      // Stage the demo is at.
 FPSCount : Integer = 0;               // Counter for FPS

 g_backRed  : GLfloat = 0.0;
 g_backGreen : GLfloat = 0.0;
 g_backBlue : GLfloat = 1.0;
 g_modifier : integer = 1;

 procedure Init; // Procedure that load texures and objects
 function  ArcTan(X, Y : glFloat) : glFloat;
 procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;

implementation

// LOADING STAGE : Load all textures and objects
procedure LoadDemoTextures;
begin
 LoadTexture('images/band.jpg', IntroBG, false);
 LoadTexture('images/volitionName.jpg',  DemoNameTex, false);
 LoadTexture('images/volitionlogo.jpg',  Logo, false);
end;

//  Function to do an arctan
function ArcTan(X, Y : glFloat) : glFloat;
asm
  FLD Y
  FLD X
  FPATAN
  FWAIT
end;

// Initialise. Loads textures and creates objects
procedure Init;
begin
  glTranslatef(0.0,0.0,-10);

  // Background image
  glBindTexture(GL_TEXTURE_2D, ProgressTex);
  glBegin(GL_QUADS);
    glTexCoord2f(0, 0); glVertex3f(-2,-0.25, 0);
    glTexCoord2f(1, 0); glVertex3f( 2,-0.25, 0);
    glTexCoord2f(1, 1); glVertex3f( 2, 0.25, 0);
    glTexCoord2f(0, 1); glVertex3f(-2, 0.25, 0);
  glEnd();

  LoadDemoTextures;

  ElapsedTime :=0;
  Inc(Stage);
end;

end.

